<template>
    <ion-modal :is-open="isOpenLocal" @willDismiss="onWillDismiss">
        <ion-header>
            <ion-toolbar>
                <ion-buttons slot="end">
                    <ion-button @click="closeModal()">Zpět</ion-button>
                </ion-buttons>
                <ion-title>Zařízení</ion-title>
            </ion-toolbar>
        </ion-header>

        <ion-content class="ion-padding">
            <ion-progress-bar
                v-if="loading"
                type="indeterminate"
            ></ion-progress-bar>
            <ion-item>
                <ion-grid>
                    <ion-row v-for="device in deviceList" :key="device.id">
                        <device-card
                            @editClick="editDevice"
                            @removeClick="remove"
                            :device="device"
                        />
                    </ion-row>
                </ion-grid>
            </ion-item>
        </ion-content>
    </ion-modal>
</template>

<script lang="ts" setup>
import {
    IonGrid,
    IonRow,
    IonProgressBar,
    IonButton,
    IonButtons,
    IonModal,
    IonHeader,
    IonContent,
    IonToolbar,
    IonTitle,
    IonItem,
} from '@ionic/vue'
import { useLazyQuery, useMutation } from '@vue/apollo-composable'
import gql from 'graphql-tag'
import { computed, ref, watch } from 'vue'
import DeviceCard from './DeviceCard.vue'
import router from '@/router'
import { Route } from '@/router/route'
import toast from '@/helpers/toast'

const props = defineProps<{
    isOpen?: boolean
    userId?: string
}>()

const emit = defineEmits(['closeModal'])

const { loading, result, load, refetch } = useLazyQuery(
    gql`
        query deviceModal($id: ID!) {
            appUser(id: $id) {
                deviceList {
                    id
                    name
                    mac
                    ip
                    isKnown
                    isKnownExpiration
                    hasInternetAccess
                    internetAccessExpiration
                    wifiName
                    wifiPass
                    isAllowed
                    createdAt
                    updatedAt
                    deviceGroupList {
                        id
                        name
                        isActive
                        createdAt
                        updatedAt
                    }
                    devicePortList {
                        id
                        hubPort
                        devicePort
                        expiration
                        createdAt
                        updatedAt
                    }
                    devicePhotoList {
                        id
                        filename
                        displayOrder
                        createdAt
                        updatedAt
                    }
                    staticIp {
                        id
                        ip
                        expiration
                        createdAt
                        updatedAt
                    }
                }
            }
        }
    `,
    () => ({ id: props.userId })
)

const deviceList = computed(() => result?.value?.appUser?.deviceList ?? [])

const isOpenLocal = ref(false)

const onWillDismiss = () => emit('closeModal')
const closeModal = () => (isOpenLocal.value = false)

watch(
    () => props.isOpen,
    (isOpen) => {
        isOpenLocal.value = isOpen
    }
)

watch(
    () => props.userId,
    () => load()
)

const editDevice = (id: string) => {
    isOpenLocal.value = false
    router.push({ name: Route.device, params: { id } })
}

// Smazat
const { mutate: removeDevice } = useMutation(gql`
    mutation removeDevice2($id: ID!) {
        removeDevice(id: $id)
    }
`)

const remove = (id: string) =>
    removeDevice({ id }).then(() => {
        refetch()
        toast(id + ' smazáno', 'success')
    })
</script>
